package com.izenpe.zain.cliente.ts;

import org.apache.axis.encoding.Base64;

import com.izenpe.zain.client.ZainConfig;
import com.izenpe.zain.cliente.util.CalcularHash;
import com.izenpe.zain.cliente.util.Constantes;
import com.izenpe.zain.cliente.util.Propiedades;
import com.izenpe.zain.cliente.util.ZainUtil;
import com.safelayer.trustedx.client.smartwrapper.Constants;
import com.safelayer.trustedx.client.smartwrapper.SmartSignRequest;
import com.safelayer.trustedx.client.smartwrapper.SmartSignResponse;


public class GeneracionTimestamp {
	
	private static final String fileName = "HelloWorld.txt";

	public static void main(String[] args) {
		try {
			
			// Asignación de la configuración de forma programática
			ZainConfig.setCurrent(Propiedades.ZAIN_CONFIG);
			
			/*
			 * Se crea la petición a través de la URL definida en ZAIN_ENDPOINT.
			 */
			SmartSignRequest smartSignReq = new SmartSignRequest(Propiedades.ZAIN_ENDPOINT);

			// Se establece el perfil de sello de tiempo en la petición de Generación
			// de firma.
			smartSignReq.setProfile(Constants.Profile.TIMESTAMPING);
			
			/*
			 * Se establece el idioma de la petición en español. 2
			 * posibilidades: 1. Español: 'es' 2. Inglés: 'en'
			 */
			smartSignReq.setLanguage("es");

			// Datos a firmar. pasamos el documento original
			//smartSignReq.setInputBase64Data(Base64.encode(ZainUtil.readBinaryFile("data/input/" + fileName)));
			
			// Datos a firmar. pasamos el hash de documento original
			smartSignReq.setInputHashAlgorithm(Constants.DigestAlgorithm.SHA1);
			String hashDoc = CalcularHash.getHash("data/input/" + fileName);
			smartSignReq.setInputHashDigest(hashDoc);

			// Envío de la petición.
			SmartSignResponse smartSignResp = smartSignReq.send();

			/*
			 * Se comprueba la validez de la respuesta y se escribe la respuesta
			 * de Generación de firma PDF en un fichero en disco.
			 */
			if (Constantes.RMAJOR_SUCCESS.equals((smartSignResp.getResultMajor()))
					&& smartSignResp.getResultMinor() == null) {
				String docPDF = smartSignResp.getTimeStamp();
				byte[] data = Base64.decode(docPDF);
				String destFilename = "data/output/" + fileName.substring(0, fileName.lastIndexOf(".")) + ".tst";
				ZainUtil.writeBinaryFile(destFilename, data);
				System.out.println("El sello de tiempo se ha generado con éxito.");
			} else {
				System.out.println("Error en la Generación del sello de tiempo:" + smartSignResp.getResultMessage());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}